Index: protocols/oscar/oscar.c
===================================================================
--- protocols/oscar/oscar.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ protocols/oscar/oscar.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -60,4 +60,7 @@
 
 #define OSCAR_GROUP "Friends"
+
+#define BUF_LEN 2048
+#define BUF_LONG ( BUF_LEN * 2 )
 
 /* Don't know if support for UTF8 is really working. For now it's UTF16 here.
@@ -240,4 +243,30 @@
 };
 static int msgerrreasonlen = 25;
+
+/* Hurray, this function is NOT thread-safe \o/ */
+static char *normalize(const char *s)
+{
+	static char buf[BUF_LEN];
+	char *t, *u;
+	int x = 0;
+
+	g_return_val_if_fail((s != NULL), NULL);
+
+	u = t = g_strdup(s);
+
+	strcpy(t, s);
+	g_strdown(t);
+
+	while (*t && (x < BUF_LEN - 1)) {
+		if (*t != ' ' && *t != '!') {
+			buf[x] = *t;
+			x++;
+		}
+		t++;
+	}
+	buf[x] = '\0';
+	g_free(u);
+	return buf;
+}
 
 static gboolean oscar_callback(gpointer data, gint source,
@@ -1002,11 +1031,11 @@
 	}
 
-	tmp = g_strdup(normalize(ic->acc->user));
-	if (!strcmp(tmp, normalize(info->sn)))
+	if (!aim_sncmp(ic->acc->user, info->sn))
 		g_snprintf(ic->displayname, sizeof(ic->displayname), "%s", info->sn);
-	g_free(tmp);
-
-	imcb_buddy_status(ic, info->sn, flags, state_string, NULL);
-	/* imcb_buddy_times(ic, info->sn, signon, time_idle); */
+
+	tmp = normalize(info->sn);
+	imcb_buddy_status(ic, tmp, flags, state_string, NULL);
+	/* imcb_buddy_times(ic, tmp, signon, time_idle); */
+
 
 	return 1;
@@ -1022,5 +1051,5 @@
 	va_end(ap);
 
-	imcb_buddy_status(ic, info->sn, 0, NULL, NULL );
+	imcb_buddy_status(ic, normalize(info->sn), 0, NULL, NULL );
 
 	return 1;
@@ -1078,5 +1107,5 @@
 	
 	strip_linefeed(tmp);
-	imcb_buddy_msg(ic, userinfo->sn, tmp, flags, 0);
+	imcb_buddy_msg(ic, normalize(userinfo->sn), tmp, flags, 0);
 	g_free(tmp);
 	
@@ -1084,6 +1113,6 @@
 }
 
-void oscar_accept_chat(gpointer w, struct aim_chat_invitation * inv);
-void oscar_reject_chat(gpointer w, struct aim_chat_invitation * inv);
+void oscar_accept_chat(void *data);
+void oscar_reject_chat(void *data);
 	
 static int incomingim_chan2(aim_session_t *sess, aim_conn_t *conn, aim_userinfo_t *userinfo, struct aim_incomingim_ch2_args *args) {
@@ -1119,5 +1148,6 @@
 }
 
-static void gaim_icq_authgrant(gpointer w, struct icq_auth *data) {
+static void gaim_icq_authgrant(void *data_) {
+	struct icq_auth *data = data_;
 	char *uin, message;
 	struct oscar_data *od = (struct oscar_data *)data->ic->proto_data;
@@ -1134,5 +1164,6 @@
 }
 
-static void gaim_icq_authdeny(gpointer w, struct icq_auth *data) {
+static void gaim_icq_authdeny(void *data_) {
+	struct icq_auth *data = data_;
 	char *uin, *message;
 	struct oscar_data *od = (struct oscar_data *)data->ic->proto_data;
@@ -1175,5 +1206,5 @@
 			message = g_strdup(args->msg);
 			strip_linefeed(message);
-			imcb_buddy_msg(ic, uin, message, 0, 0);
+			imcb_buddy_msg(ic, normalize(uin), message, 0, 0);
 			g_free(uin);
 			g_free(message);
@@ -1194,5 +1225,5 @@
 
 			strip_linefeed(message);
-			imcb_buddy_msg(ic, uin, message, 0, 0);
+			imcb_buddy_msg(ic, normalize(uin), message, 0, 0);
 			g_free(uin);
 			g_free(m);
@@ -1469,5 +1500,5 @@
 
 	for (i = 0; i < count; i++)
-		imcb_chat_add_buddy(c->cnv, info[i].sn);
+		imcb_chat_add_buddy(c->cnv, normalize(info[i].sn));
 
 	return 1;
@@ -1492,5 +1523,5 @@
 
 	for (i = 0; i < count; i++)
-		imcb_chat_remove_buddy(c->cnv, info[i].sn, NULL);
+		imcb_chat_remove_buddy(c->cnv, normalize(info[i].sn), NULL);
 
 	return 1;
@@ -1543,5 +1574,5 @@
 	tmp = g_malloc(BUF_LONG);
 	g_snprintf(tmp, BUF_LONG, "%s", msg);
-	imcb_chat_msg(ccon->cnv, info->sn, tmp, 0, 0);
+	imcb_chat_msg(ccon->cnv, normalize(info->sn), tmp, 0, 0);
 	g_free(tmp);
 
@@ -1756,5 +1787,5 @@
 			g_snprintf(sender, sizeof(sender), "%u", msg->sender);
 			strip_linefeed(dialog_msg);
-			imcb_buddy_msg(ic, sender, dialog_msg, 0, t);
+			imcb_buddy_msg(ic, normalize(sender), dialog_msg, 0, t);
 			g_free(dialog_msg);
 		} break;
@@ -1777,5 +1808,5 @@
 
 			strip_linefeed(dialog_msg);
-			imcb_buddy_msg(ic, sender, dialog_msg, 0, t);
+			imcb_buddy_msg(ic, normalize(sender), dialog_msg, 0, t);
 			g_free(dialog_msg);
 			g_free(m);
@@ -2015,11 +2046,14 @@
 	struct aim_ssi_item *curitem;
 	int tmp;
+	char *nrm;
 
 	/* Add from server list to local list */
 	tmp = 0;
 	for (curitem=sess->ssi.items; curitem; curitem=curitem->next) {
+		nrm = curitem->name ? normalize(curitem->name) : NULL;
+		
 		switch (curitem->type) {
 			case 0x0000: /* Buddy */
-				if ((curitem->name) && (!imcb_find_buddy(ic, curitem->name))) {
+				if ((curitem->name) && (!imcb_find_buddy(ic, nrm))) {
 					char *realname = NULL;
 
@@ -2027,9 +2061,9 @@
 						    realname = aim_gettlv_str(curitem->data, 0x0131, 1);
 						
-					imcb_add_buddy(ic, curitem->name, NULL);
+					imcb_add_buddy(ic, nrm, NULL);
 					
 					if (realname) {
-						imcb_buddy_nick_hint(ic, curitem->name, realname);
-						imcb_rename_buddy(ic, curitem->name, realname);
+						imcb_buddy_nick_hint(ic, nrm, realname);
+						imcb_rename_buddy(ic, nrm, realname);
 						g_free(realname);
 					}
@@ -2043,5 +2077,5 @@
 					if (!list) {
 						char *name;
-						name = g_strdup(normalize(curitem->name));
+						name = g_strdup(nrm);
 						ic->permit = g_slist_append(ic->permit, name);
 						tmp++;
@@ -2056,5 +2090,5 @@
 					if (!list) {
 						char *name;
-						name = g_strdup(normalize(curitem->name));
+						name = g_strdup(nrm);
 						ic->deny = g_slist_append(ic->deny, name);
 						tmp++;
@@ -2118,5 +2152,5 @@
 			if( st == 0x00 )
 			{
-				imcb_add_buddy( sess->aux_data, list, NULL );
+				imcb_add_buddy( sess->aux_data, normalize(list), NULL );
 			}
 			else if( st == 0x0E )
@@ -2448,13 +2482,13 @@
 	if(type2 == 0x0002) {
 		/* User is typing */
-		imcb_buddy_typing(ic, sn, OPT_TYPING);
+		imcb_buddy_typing(ic, normalize(sn), OPT_TYPING);
 	} 
 	else if (type2 == 0x0001) {
 		/* User has typed something, but is not actively typing (stale) */
-		imcb_buddy_typing(ic, sn, OPT_THINKING);
+		imcb_buddy_typing(ic, normalize(sn), OPT_THINKING);
 	}
 	else {
 		/* User has stopped typing */
-		imcb_buddy_typing(ic, sn, 0);
+		imcb_buddy_typing(ic, normalize(sn), 0);
 	}
 	
@@ -2588,6 +2622,8 @@
 }
 
-void oscar_accept_chat(gpointer w, struct aim_chat_invitation * inv)
-{
+void oscar_accept_chat(void *data)
+{
+	struct aim_chat_invitation * inv = data;
+	
 	oscar_chat_join(inv->ic, inv->name, NULL, NULL);
 	g_free(inv->name);
@@ -2595,6 +2631,8 @@
 }
 
-void oscar_reject_chat(gpointer w, struct aim_chat_invitation * inv)
-{
+void oscar_reject_chat(void *data)
+{
+	struct aim_chat_invitation * inv = data;
+	
 	g_free(inv->name);
 	g_free(inv);
Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ protocols/yahoo/libyahoo2.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -69,6 +69,4 @@
 #ifdef __MINGW32__
 # include <winsock2.h>
-# define write(a,b,c) send(a,b,c,0)
-# define read(a,b,c)  recv(a,b,c,0)
 #endif
 
@@ -381,5 +379,4 @@
 
 /* call repeatedly to get the next one */
-/*
 static struct yahoo_input_data * find_input_by_id(int id)
 {
@@ -392,5 +389,4 @@
 	return NULL;
 }
-*/
 
 static struct yahoo_input_data * find_input_by_id_and_webcam_user(int id, const char * who)
@@ -737,5 +733,5 @@
 
 	memcpy(data + pos, "YMSG", 4); pos += 4;
-	pos += yahoo_put16(data + pos, 0x0a00);
+	pos += yahoo_put16(data + pos, 0x000c);
 	pos += yahoo_put16(data + pos, 0x0000);
 	pos += yahoo_put16(data + pos, pktlen + extra_pad);
@@ -797,4 +793,5 @@
 {
 	struct yahoo_data *yd = find_conn_by_id(id);
+	
 	if(!yd)
 		return;
@@ -3166,5 +3163,5 @@
 
 	LOG(("write callback: id=%d fd=%d data=%p", id, fd, data));
-	if(!yid || !yid->txqueues)
+	if(!yid || !yid->txqueues || !find_conn_by_id(id))
 		return -2;
 	
@@ -3351,5 +3348,5 @@
 					break;
 				case 5: 
-					if(cp != "\005")
+					if(strcmp(cp, "5") != 0)
 						yct->location = cp;
 					k = 0;
@@ -3842,9 +3839,7 @@
 	}
 
-	
-/*	do {
+	do {
 		yahoo_input_close(yid);
-	} while((yid = find_input_by_id(id)));*/
-	
+	} while((yid = find_input_by_id(id)));
 }
 
Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ protocols/yahoo/yahoo.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -163,8 +163,5 @@
 	g_slist_free( yd->buddygroups );
 	
-	if( yd->logged_in )
-		yahoo_logoff( yd->y2_id );
-	else
-		yahoo_close( yd->y2_id );
+	yahoo_logoff( yd->y2_id );
 	
 	g_free( yd );
@@ -315,5 +312,5 @@
 	struct byahoo_data *yd = (struct byahoo_data *) c->ic->proto_data;
 	
-	yahoo_conference_invite( yd->y2_id, NULL, c->data, c->title, msg );
+	yahoo_conference_invite( yd->y2_id, NULL, c->data, c->title, msg ? msg : "" );
 }
 
@@ -454,8 +451,4 @@
 {
 	struct byahoo_write_ready_data *d = data;
-	
-	if( !byahoo_get_ic_by_id( d->id ) )
-		/* WTF doesn't libyahoo clean this up? */
-		return FALSE;
 	
 	yahoo_write_ready( d->id, d->fd, d->data );
@@ -798,6 +791,8 @@
 }
 
-static void byahoo_accept_conf( gpointer w, struct byahoo_conf_invitation *inv )
-{
+static void byahoo_accept_conf( void *data )
+{
+	struct byahoo_conf_invitation *inv = data;
+	
 	yahoo_conference_logon( inv->yid, NULL, inv->members, inv->name );
 	imcb_chat_add_buddy( inv->c, inv->ic->acc->user );
@@ -806,6 +801,8 @@
 }
 
-static void byahoo_reject_conf( gpointer w, struct byahoo_conf_invitation *inv )
-{
+static void byahoo_reject_conf( void *data )
+{
+	struct byahoo_conf_invitation *inv = data;
+	
 	yahoo_conference_decline( inv->yid, NULL, inv->members, inv->name, "User rejected groupchat" );
 	imcb_chat_free( inv->c );
Index: protocols/yahoo/yahoo_httplib.c
===================================================================
--- protocols/yahoo/yahoo_httplib.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ protocols/yahoo/yahoo_httplib.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -51,6 +51,4 @@
 #ifdef __MINGW32__
 # include <winsock2.h>
-# define write(a,b,c) send(a,b,c,0)
-# define read(a,b,c)  recv(a,b,c,0)
 # define snprintf _snprintf
 #endif
Index: query.c
===================================================================
--- query.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ query.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -30,5 +30,6 @@
 static query_t *query_default( irc_t *irc );
 
-query_t *query_add( irc_t *irc, struct im_connection *ic, char *question, void *yes, void *no, void *data )
+query_t *query_add( irc_t *irc, struct im_connection *ic, char *question,
+                    query_callback yes, query_callback no, void *data )
 {
 	query_t *q = g_new0( query_t, 1 );
@@ -143,19 +144,19 @@
 	if( ans )
 	{
-		if(q->ic)
+		if( q->ic )
 			imcb_log( q->ic, "Accepted: %s", q->question );
 		else
 			irc_usermsg( irc, "Accepted: %s", q->question );
-		if(q->yes)
-			q->yes( q->ic ? (gpointer)q->ic : (gpointer)irc, q->data );
+		if( q->yes )
+			q->yes( q->data );
 	}
 	else
 	{
-		if(q->ic)
+		if( q->ic )
 			imcb_log( q->ic, "Rejected: %s", q->question );
 		else
 			irc_usermsg( irc, "Rejected: %s", q->question );
-		if(q->no)
-			q->no( q->ic ? (gpointer)q->ic : (gpointer)irc, q->data );
+		if( q->no )
+			q->no( q->data );
 	}
 	q->data = NULL;
Index: query.h
===================================================================
--- query.h	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ query.h	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -27,15 +27,17 @@
 #define _QUERY_H
 
+typedef void (*query_callback) ( void *data );
+
 typedef struct query
 {
 	struct im_connection *ic;
 	char *question;
-	void (* yes) ( gpointer w, void *data );
-	void (* no) ( gpointer w, void *data );
+	query_callback yes, no;
 	void *data;
 	struct query *next;
 } query_t;
 
-query_t *query_add( irc_t *irc, struct im_connection *ic, char *question, void *yes, void *no, void *data );
+query_t *query_add( irc_t *irc, struct im_connection *ic, char *question,
+                    query_callback yes, query_callback no, void *data );
 void query_del( irc_t *irc, query_t *q );
 void query_del_by_conn( irc_t *irc, struct im_connection *ic );
Index: root_commands.c
===================================================================
--- root_commands.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ root_commands.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -205,4 +205,38 @@
 }
 
+struct cmd_account_del_data
+{
+	account_t *a;
+	irc_t *irc;
+};
+
+void cmd_account_del_yes( void *data )
+{
+	struct cmd_account_del_data *cad = data;
+	account_t *a;
+	
+	for( a = cad->irc->accounts; a && a != cad->a; a = a->next );
+	
+	if( a == NULL )
+	{
+		irc_usermsg( cad->irc, "Account already deleted" );
+	}
+	else if( a->ic )
+	{
+		irc_usermsg( cad->irc, "Account is still logged in, can't delete" );
+	}
+	else
+	{
+		account_del( cad->irc, a );
+		irc_usermsg( cad->irc, "Account deleted" );
+	}
+	g_free( data );
+}
+
+void cmd_account_del_no( void *data )
+{
+	g_free( data );
+}
+
 static void cmd_account( irc_t *irc, char **cmd )
 {
@@ -263,6 +297,18 @@
 		else
 		{
-			account_del( irc, a );
-			irc_usermsg( irc, "Account deleted" );
+			struct cmd_account_del_data *cad;
+			char *msg;
+			
+			cad = g_malloc( sizeof( struct cmd_account_del_data ) );
+			cad->a = a;
+			cad->irc = irc;
+			
+			msg = g_strdup_printf( "If you remove this account (%s(%s)), BitlBee will "
+			                       "also forget all your saved nicknames. If you want "
+			                       "to change your username/password, use the `account "
+			                       "set' command. Are you sure you want to delete this "
+			                       "account?", a->prpl->name, a->user );
+			query_add( irc, NULL, msg, cmd_account_del_yes, cmd_account_del_no, cad );
+			g_free( msg );
 		}
 	}
@@ -382,4 +428,10 @@
 			acc_handle = g_strdup( cmd[2] );
 		
+		if( !acc_handle )
+		{
+			irc_usermsg( irc, "Not enough parameters given (need %d)", 3 );
+			return;
+		}
+		
 		if( ( tmp = strchr( acc_handle, '/' ) ) )
 		{
@@ -562,4 +614,7 @@
 			g_free( irc->mynick );
 			irc->mynick = g_strdup( cmd[2] );
+			
+			if( strcmp( cmd[0], "set_rename" ) != 0 )
+				set_setstr( &irc->set, "root_nick", cmd[2] );
 		}
 		else if( u->send_handler == buddy_send_handler )
@@ -570,4 +625,18 @@
 		irc_usermsg( irc, "Nick successfully changed" );
 	}
+}
+
+char *set_eval_root_nick( set_t *set, char *new_nick )
+{
+	irc_t *irc = set->data;
+	
+	if( strcmp( irc->mynick, new_nick ) != 0 )
+	{
+		char *cmd[] = { "set_rename", irc->mynick, new_nick, NULL };
+		
+		cmd_rename( irc, cmd );
+	}
+	
+	return strcmp( irc->mynick, new_nick ) == 0 ? new_nick : NULL;
 }
 
@@ -774,4 +843,7 @@
 		else
 			irc_usermsg( irc, "%s is empty", set_name );
+
+		if( strchr( set_name, '/' ) )
+			irc_usermsg( irc, "Warning: / found in setting name, you're probably looking for the `account set' command." );
 	}
 	else
Index: set.c
===================================================================
--- set.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ set.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -357,19 +357,4 @@
 }
 
-char *set_eval_charset( set_t *set, char *value )
-{
-	GIConv cd;
-
-	if ( g_strncasecmp( value, "none", 4 ) == 0 )
-		return value;
-
-	cd = g_iconv_open( "UTF-8", value );
-	if( cd == (GIConv) -1 )
-		return NULL;
-
-	g_iconv_close( cd );
-	return value;
-}
-
 /* possible values: never, opportunistic, manual, always */
 char *set_eval_otr_policy( set_t *set, char *value )
Index: set.h
===================================================================
--- set.h	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ set.h	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -101,5 +101,4 @@
 char *set_eval_halfop_buddies( set_t *set, char *value );
 char *set_eval_voice_buddies( set_t *set, char *value );
-char *set_eval_charset( set_t *set, char *value );
 char *set_eval_otr_policy( set_t *set, char *value );
 
Index: sock.h
===================================================================
--- sock.h	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ sock.h	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -16,15 +16,9 @@
 #else
 # include <winsock2.h>
-# ifndef _MSC_VER
-#  include <ws2tcpip.h>
-# endif
+# include <ws2tcpip.h>
 # if !defined(BITLBEE_CORE) && defined(_MSC_VER)
 #   pragma comment(lib,"bitlbee.lib")
 # endif
 # include <io.h>
-# define read(a,b,c) recv(a,b,c,0)
-# define write(a,b,c) send(a,b,c,0)
-# define umask _umask
-# define mode_t int
 # define sock_make_nonblocking(fd) { int non_block = 1; ioctlsocket(fd, FIONBIO, &non_block); }
 # define sock_make_blocking(fd) { int non_block = 0; ioctlsocket(fd, FIONBIO, &non_block); }
Index: storage_text.c
===================================================================
--- storage_text.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ storage_text.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -27,4 +27,12 @@
 #include "bitlbee.h"
 #include "crypting.h"
+#ifdef _WIN32
+# define umask _umask
+# define mode_t int
+#endif
+
+#ifndef F_OK
+#define F_OK 0
+#endif
 
 static void text_init (void)
Index: storage_xml.c
===================================================================
--- storage_xml.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ storage_xml.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -29,4 +29,10 @@
 #include "arc.h"
 #include "md5.h"
+#include <glib/gstdio.h>
+
+#if !GLIB_CHECK_VERSION(2,8,0)
+/* GLib < 2.8.0 doesn't have g_access, so just use the system access(). */
+#define g_access access
+#endif
 
 typedef enum
@@ -80,5 +86,5 @@
 		char *nick = xml_attr( attr_names, attr_values, "nick" );
 		char *pass = xml_attr( attr_names, attr_values, "password" );
-		md5_byte_t *pass_dec = NULL;
+		int st;
 		
 		if( !nick || !pass )
@@ -87,40 +93,21 @@
 			             "Missing attributes for %s element", element_name );
 		}
-		else if( base64_decode( pass, &pass_dec ) != 21 )
-		{
+		else if( ( st = md5_verify_password( xd->given_pass, pass ) ) == -1 )
+		{
+			xd->pass_st = XML_PASS_WRONG;
 			g_set_error( error, G_MARKUP_ERROR, G_MARKUP_ERROR_INVALID_CONTENT,
 			             "Error while decoding password attribute" );
 		}
+		else if( st == 0 )
+		{
+			if( xd->pass_st != XML_PASS_CHECK_ONLY )
+				xd->pass_st = XML_PASS_OK;
+		}
 		else
 		{
-			md5_byte_t pass_md5[16];
-			md5_state_t md5_state;
-			int i;
-			
-			md5_init( &md5_state );
-			md5_append( &md5_state, (md5_byte_t*) xd->given_pass, strlen( xd->given_pass ) );
-			md5_append( &md5_state, (md5_byte_t*) pass_dec + 16, 5 ); /* Hmmm, salt! */
-			md5_finish( &md5_state, pass_md5 );
-			
-			for( i = 0; i < 16; i ++ )
-			{
-				if( pass_dec[i] != pass_md5[i] )
-				{
-					xd->pass_st = XML_PASS_WRONG;
-					g_set_error( error, G_MARKUP_ERROR, G_MARKUP_ERROR_INVALID_CONTENT,
-					             "Password mismatch" );
-					break;
-				}
-			}
-			
-			/* If we reached the end of the loop, it was a match! */
-			if( i == 16 )
-			{
-				if( xd->pass_st != XML_PASS_CHECK_ONLY )
-					xd->pass_st = XML_PASS_OK;
-			}
-		}
-		
-		g_free( pass_dec );
+			xd->pass_st = XML_PASS_WRONG;
+			g_set_error( error, G_MARKUP_ERROR, G_MARKUP_ERROR_INVALID_CONTENT,
+			             "Password mismatch" );
+		}
 	}
 	else if( xd->pass_st < XML_PASS_OK )
@@ -262,7 +249,8 @@
 static void xml_init( void )
 {
-	if( access( global.conf->configdir, F_OK ) != 0 )
+	if( g_access( global.conf->configdir, F_OK ) != 0 )
 		log_message( LOGLVL_WARNING, "The configuration directory `%s' does not exist. Configuration won't be saved.", global.conf->configdir );
-	else if( access( global.conf->configdir, R_OK ) != 0 || access( global.conf->configdir, W_OK ) != 0 )
+	else if( g_access( global.conf->configdir, F_OK ) != 0 || 
+	         g_access( global.conf->configdir, W_OK ) != 0 )
 		log_message( LOGLVL_WARNING, "Permission problem: Can't read/write from/to `%s'.", global.conf->configdir );
 }
@@ -391,5 +379,5 @@
 	g_free( path2 );
 	
-	if( !overwrite && access( path, F_OK ) != -1 )
+	if( !overwrite && g_access( path, F_OK ) == 0 )
 		return STORAGE_ALREADY_EXISTS;
 	
@@ -428,5 +416,5 @@
 		int pass_len;
 		
-		pass_len = arc_encode( acc->pass, strlen( acc->pass ), (unsigned char**) &pass_cr, irc->password );
+		pass_len = arc_encode( acc->pass, strlen( acc->pass ), (unsigned char**) &pass_cr, irc->password, 12 );
 		pass_b64 = base64_encode( pass_cr, pass_len );
 		g_free( pass_cr );
@@ -499,5 +487,5 @@
 static storage_status_t xml_remove( const char *nick, const char *password )
 {
-	char s[512];
+	char s[512], *lc;
 	storage_status_t status;
 
@@ -506,5 +494,9 @@
 		return status;
 
-	g_snprintf( s, 511, "%s%s%s", global.conf->configdir, nick, ".xml" );
+	lc = g_strdup( nick );
+	nick_lc( lc );
+	g_snprintf( s, 511, "%s%s%s", global.conf->configdir, lc, ".xml" );
+	g_free( lc );
+	
 	if( unlink( s ) == -1 )
 		return STORAGE_OTHER_ERROR;
Index: tests/Makefile
===================================================================
--- tests/Makefile	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ tests/Makefile	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -13,5 +13,5 @@
 main_objs = account.o bitlbee.o conf.o crypting.o help.o ipc.o irc.o irc_commands.o log.o nick.o query.o root_commands.o set.o storage.o storage_xml.o storage_text.o user.o
 
-test_objs = check.o check_util.o check_nick.o check_md5.o check_arc.o check_irc.o check_help.o check_user.o check_crypting.o check_set.o check_jabber_sasl.o
+test_objs = check.o check_util.o check_nick.o check_md5.o check_arc.o check_irc.o check_help.o check_user.o check_crypting.o check_set.o check_jabber_sasl.o check_jabber_util.o
 
 check: $(test_objs) $(addprefix ../, $(main_objs)) ../protocols/protocols.o ../lib/lib.o
Index: tests/check.c
===================================================================
--- tests/check.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ tests/check.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -69,4 +69,7 @@
 Suite *jabber_sasl_suite(void);
 
+/* From check_jabber_sasl.c */
+Suite *jabber_util_suite(void);
+
 int main (int argc, char **argv)
 {
@@ -115,4 +118,5 @@
 	srunner_add_suite(sr, set_suite());
 	srunner_add_suite(sr, jabber_sasl_suite());
+	srunner_add_suite(sr, jabber_util_suite());
 	if (no_fork)
 		srunner_set_fork_status(sr, CK_NOFORK);
Index: tests/check_arc.c
===================================================================
--- tests/check_arc.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ tests/check_arc.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -7,5 +7,5 @@
 #include "arc.h"
 
-char *password = "TotT";
+char *password = "ArcVier";
 
 char *clear_tests[] =
@@ -14,4 +14,5 @@
 	"ItllBeBitlBee",
 	"One more boring password",
+	"Hoi hoi",
 	NULL
 };
@@ -28,5 +29,5 @@
 		int len;
 		
-		len = arc_encode( clear_tests[i], 0, &crypted, password );
+		len = arc_encode( clear_tests[i], 0, &crypted, password, 12 );
 		len = arc_decode( crypted, len, &decrypted, password );
 		
@@ -41,25 +42,33 @@
 struct
 {
-	unsigned char crypted[24];
+	unsigned char crypted[30];
 	int len;
 	char *decrypted;
 } decrypt_tests[] = {
+	/* One block with padding. */
 	{
 		{
-			0xc3, 0x0d, 0x43, 0xc3, 0xee, 0x80, 0xe2, 0x8c, 0x0b, 0x29, 0x32, 0x7e,
-			0x38, 0x05, 0x82, 0x10, 0x21, 0x1c, 0x4a, 0x00, 0x2c
-		}, 21, "Debugging sucks"
+			0x3f, 0x79, 0xb0, 0xf5, 0x91, 0x56, 0xd2, 0x1b, 0xd1, 0x4b, 0x67, 0xac,
+			0xb1, 0x31, 0xc9, 0xdb, 0xf9, 0xaa
+		}, 18, "short pass"
 	},
+	
+	/* Two blocks with padding. */
 	{
 		{
-			0xb0, 0x00, 0x57, 0x0d, 0x0d, 0x0d, 0x70, 0xe1, 0xc0, 0x00, 0xa4, 0x25,
-			0x7d, 0xbe, 0x03, 0xcc, 0x24, 0xd1, 0x0c
-		}, 19, "Testing rocks"
+			0xf9, 0xa6, 0xec, 0x5d, 0xc7, 0x06, 0xb8, 0x6b, 0x63, 0x9f, 0x2d, 0xb5,
+			0x7d, 0xaa, 0x32, 0xbb, 0xd8, 0x08, 0xfd, 0x81, 0x2e, 0xca, 0xb4, 0xd7,
+			0x2f, 0x36, 0x9c, 0xac, 0xa0, 0xbc
+		}, 30, "longer password"
 	},
+
+	/* This string is exactly two "blocks" long, to make sure unpadded strings also decrypt
+	   properly. */
 	{
 		{
-			0xb6, 0x92, 0x59, 0xe4, 0xf9, 0xc1, 0x7a, 0xf6, 0xf3, 0x18, 0xea, 0x28,
-			0x73, 0x6d, 0xb3, 0x0a, 0x6f, 0x0a, 0x2b, 0x43, 0x57, 0xe9, 0x3e, 0x63
-		}, 24, "OSCAR is creepy..."
+			0x95, 0x4d, 0xcf, 0x4d, 0x5e, 0x6c, 0xcf, 0xef, 0xb9, 0x80, 0x00, 0xef,
+			0x25, 0xe9, 0x17, 0xf6, 0x29, 0x6a, 0x82, 0x79, 0x1c, 0xca, 0x68, 0xb5,
+			0x4e, 0xd0, 0xc1, 0x41, 0x8e, 0xe6
+		}, 30, "OSCAR is really creepy.."
 	},
 	{ "", 0, NULL }
@@ -80,5 +89,5 @@
 		
 		fail_if( strcmp( decrypt_tests[i].decrypted, decrypted ) != 0,
-		         "%s didn't decrypt properly", clear_tests[i] );
+		         "`%s' didn't decrypt properly", decrypt_tests[i].decrypted );
 		
 		g_free( decrypted );
Index: tests/check_irc.c
===================================================================
--- tests/check_irc.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ tests/check_irc.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -37,6 +37,6 @@
 	irc = irc_new(g_io_channel_unix_get_fd(ch1));
 
-	fail_unless(g_io_channel_write_chars(ch2, "NICK bla\r\n"
-			"USER a a a a\r\n", -1, NULL, NULL) == G_IO_STATUS_NORMAL);
+	fail_unless(g_io_channel_write_chars(ch2, "NICK bla\r\r\n"
+			"USER a a a a\n", -1, NULL, NULL) == G_IO_STATUS_NORMAL);
 	fail_unless(g_io_channel_flush(ch2, NULL) == G_IO_STATUS_NORMAL);
 
Index: tests/check_jabber_sasl.c
===================================================================
--- tests/check_jabber_sasl.c	(revision eb0714d7be4f57b92231fcc1b0798c7fe644c000)
+++ tests/check_jabber_sasl.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -5,5 +5,4 @@
 #include <string.h>
 #include <stdio.h>
-#include "arc.h"
 
 char *sasl_get_part( char *data, char *field );
Index: tests/check_jabber_util.c
===================================================================
--- tests/check_jabber_util.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
+++ tests/check_jabber_util.c	(revision 9b55485a6f9d72334b372e6fb6b60bbde943170d)
@@ -0,0 +1,91 @@
+#include <stdlib.h>
+#include <glib.h>
+#include <gmodule.h>
+#include <check.h>
+#include <string.h>
+#include <stdio.h>
+#include "jabber/jabber.h"
+
+static struct im_connection *ic;
+
+static void check_buddy_add(int l)
+{
+	struct jabber_buddy *budw1, *budw2, *budw3, *budn, *bud;
+	
+	budw1 = jabber_buddy_add( ic, "wilmer@gaast.net/BitlBee" );
+	budw1->last_act = time( NULL ) - 100;
+	budw2 = jabber_buddy_add( ic, "WILMER@gaast.net/Telepathy" );
+	budw2->priority = 2;
+	budw2->last_act = time( NULL );
+	budw3 = jabber_buddy_add( ic, "wilmer@GAAST.NET/bitlbee" );
+	budw3->last_act = time( NULL ) - 200;
+	budw3->priority = 4;
+	/* TODO(wilmer): Shouldn't this just return budw3? */
+	fail_if( jabber_buddy_add( ic, "wilmer@gaast.net/Telepathy" ) != NULL );
+	
+	budn = jabber_buddy_add( ic, "nekkid@lamejab.net" );
+	/* Shouldn't be allowed if there's already a bare JID. */
+	fail_if( jabber_buddy_add( ic, "nekkid@lamejab.net/Illegal" ) );
+	
+	/* Case sensitivity: Case only matters after the / */
+	fail_if( jabber_buddy_by_jid( ic, "wilmer@gaast.net/BitlBee", 0 ) ==
+	         jabber_buddy_by_jid( ic, "wilmer@gaast.net/bitlbee", 0 ) );
+	fail_if( jabber_buddy_by_jid( ic, "wilmer@gaast.net/telepathy", 0 ) );
+	
+	fail_unless( jabber_buddy_by_jid( ic, "wilmer@gaast.net/BitlBee", 0 ) == budw1 );
+	fail_unless( jabber_buddy_by_jid( ic, "WILMER@GAAST.NET/BitlBee", GET_BUDDY_EXACT ) == budw1 );
+	fail_unless( jabber_buddy_by_jid( ic, "wilmer@GAAST.NET/BitlBee", GET_BUDDY_CREAT ) == budw1 );
+
+	fail_if( jabber_buddy_by_jid( ic, "wilmer@gaast.net", GET_BUDDY_EXACT ) );
+	fail_unless( jabber_buddy_by_jid( ic, "WILMER@gaast.net", 0 ) == budw3 );
+
+	/* Check O_FIRST and see if it's indeed the first item from the list. */
+	fail_unless( ( bud = jabber_buddy_by_jid( ic, "wilmer@gaast.net", GET_BUDDY_FIRST ) ) == budw1 );
+	fail_unless( bud->next == budw2 && bud->next->next == budw3 && bud->next->next->next == NULL );
+	
+	/* Change the resource_select setting, now we should get a different resource. */
+	set_setstr( &ic->acc->set, "resource_select", "activity" );
+	fail_unless( jabber_buddy_by_jid( ic, "wilmer@GAAST.NET", 0 ) == budw2 );
+	
+	/* Some testing of bare JID handling (which is horrible). */
+	fail_if( jabber_buddy_by_jid( ic, "nekkid@lamejab.net/Illegal", 0 ) );
+	fail_if( jabber_buddy_by_jid( ic, "NEKKID@LAMEJAB.NET/Illegal", GET_BUDDY_CREAT ) );
+	fail_unless( jabber_buddy_by_jid( ic, "nekkid@lamejab.net", 0 ) == budn );
+	fail_unless( jabber_buddy_by_jid( ic, "NEKKID@lamejab.net", GET_BUDDY_EXACT ) == budn );
+	fail_unless( jabber_buddy_by_jid( ic, "nekkid@LAMEJAB.NET", GET_BUDDY_CREAT ) == budn );
+	
+	/* More case sensitivity testing, and see if remove works properly. */
+	fail_if( jabber_buddy_remove( ic, "wilmer@gaast.net/telepathy" ) );
+	fail_if( jabber_buddy_by_jid( ic, "wilmer@GAAST.NET/telepathy", GET_BUDDY_CREAT ) == budw2 );
+	fail_unless( jabber_buddy_remove( ic, "wilmer@gaast.net/Telepathy" ) );
+	fail_unless( jabber_buddy_remove( ic, "wilmer@gaast.net/telepathy" ) );
+	fail_unless( jabber_buddy_by_jid( ic, "wilmer@gaast.net", 0 ) == budw1 );
+	
+	fail_if( jabber_buddy_remove( ic, "wilmer@gaast.net" ) );
+	fail_unless( jabber_buddy_by_jid( ic, "wilmer@gaast.net", 0 ) == budw1 );
+	
+	/* Check if remove_bare() indeed gets rid of all. */
+	fail_unless( jabber_buddy_remove_bare( ic, "wilmer@gaast.net" ) );
+	fail_if( jabber_buddy_by_jid( ic, "wilmer@gaast.net", 0 ) );
+
+	fail_if( jabber_buddy_remove( ic, "nekkid@lamejab.net/Illegal" ) );
+	fail_unless( jabber_buddy_remove( ic, "nekkid@lamejab.net" ) );
+	fail_if( jabber_buddy_by_jid( ic, "nekkid@lamejab.net", 0 ) );
+}
+
+Suite *jabber_util_suite (void)
+{
+	Suite *s = suite_create("jabber/util");
+	TCase *tc_core = tcase_create("Buddy");
+	struct jabber_data *jd;
+	
+	ic = g_new0( struct im_connection, 1 );
+	ic->acc = g_new0( account_t, 1 );
+	ic->proto_data = jd = g_new0( struct jabber_data, 1 );
+	jd->buddies = g_hash_table_new( g_str_hash, g_str_equal );
+	set_add( &ic->acc->set, "resource_select", "priority", NULL, ic->acc );
+	
+	suite_add_tcase (s, tc_core);
+	tcase_add_test (tc_core, check_buddy_add);
+	return s;
+}
